Core - Feature # 24463

Epic # 55575 (Accepted): Streamline JavaScript Code in the TYPO3 Backend

Status: Closed Priority: Should have
Author: Anonymous Category:

Created: 2011-01-03 Assigned To: Steffen Gebert
Updated: 2015-03-25 Due date:

PHP Version:

Complexity:

Sprint Focus:

Subject: Add Javascript-Files from CDN

Description

At this moment, there is no possibility to load Javascript-Files from the internet.
The PageRenderer will insert only local files:

Sproperties['file'] = t3lib_div::resolveBackPath($properties['file’]);
Sproperties['file'] = t3lib_div::createVersionNumberedFilename($properties[file']);

So if | use the follow config in HOOK:

$params|'jsLibs'][jQueryTOOLS'] = array(
file’ => 'https://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js',
'section' => t3lib_PageRenderer::PART_HEADER,
‘forceOnTop' => true,

);

The file will not be loaded, because it is not on the filesystem.

This should work for jsLibs and jsFile

Best regards
Jirgen

(issue imported from #M16903)

History

#1 - 2011-01-04 00:18 - Anonymous

Please close this Issue.
After some trying, it seems to work fine.

Best regards

Jargen

#2 - 2011-01-04 11:11 - Steffen Gebert

Jirgen, would be nice if you could explain, how you solved this issue (could help others..). In this case, please reopen!

You can use the external = 1 attribute to disable the file_exists() checks. At least in TypoScript it's available.

page.includeJS.jQuery = http://cdn.whatever
page.includedS.jQuery.external = 1
http://cdn.whatever

#3 - 2011-01-04 19:42 - Anonymous

I include the script by HOOK:
$GLOBALS[TYPO3_CONF_VARST'SC_OPTIONS['t3lib/class.t3lib_pagerenderer.php']['render-preProcess']['jquery'] =
"EXT:myext/class.tx_myclass.php:&tx_myext->addJgByHook";
The Methode looks like this:
class tx_myext {
function addJgByHook($params) {
$params|['jsLibs'|'jQuery'] = array(

'file' => 'https://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js’,

'section’ => t3lib_PageRenderer::PART_HEADER,

‘forceOnTop' => true,

This will work in Typo3 4.3.x and newer

#4 - 2011-01-04 19:45 - Steffen Gebert

Um... It's really bad that it seems not to be possible to set "external” attribute using PHP API.

However for your case, | would recommend you to add it using TypoScript

#5 - 2011-01-04 19:49 - Anonymous

Sorry, seems to be a misunderstanding, the methode above works.
| had the feeling it does not work, so | reported it as a bug.

So in first place the bug report of mine was the bug ;)

#6 - 2011-01-04 19:51 - Steffen Gebert

Yes, but it's a bad method ;-)

We have an API for that t3lib_pageRenderer::addJsFile(), however this is not able to cope with the "external” flag.

#7 - 2011-01-04 19:55 - Anonymous

Yea, | know

But | have to use it, because | cant use the pageRenderer in This way.
When | set the Script, the pagerenderer isnt set to $GLOBALS.

The EXT | use there is t3jquery, hard thing ;)

#8 - 2014-02-02 11:26 - Daniel Siepmann
- Target version deleted (0)

- Parent task set to #55575

#9 - 2015-01-09 19:31 - Benjamin Mack
- Status changed from Accepted to Needs Feedback

Hey Jirgen,

could we close this one now?

#10 - 2015-01-13 11:26 - Anonymous

Yes, close it, | stopped developping for TYPO3, so | do not need this anymore

#11 - 2015-03-25 01:16 - Benjamin Mack
- Status changed from Needs Feedback to Closed
